Package org.apache.sysds.runtime.compress.colgroup

## Class ColGroupDeltaDDC

- java.lang.Object
- - org.apache.sysds.runtime.compress.colgroup.AColGroup
  - - org.apache.sysds.runtime.compress.colgroup.AColGroupCompressed
    - - org.apache.sysds.runtime.compress.colgroup.AColGroupValue
      - - org.apache.sysds.runtime.compress.colgroup.APreAgg
        - - org.apache.sysds.runtime.compress.colgroup.ColGroupDDC
          - - org.apache.sysds.runtime.compress.colgroup.ColGroupDeltaDDC

All Implemented Interfaces:
  `Serializable`, `Cloneable`

    public class ColGroupDeltaDDC
    extends ColGroupDDC

Class to encapsulate information about a column group that is first delta encoded then encoded with dense dictionary encoding (DeltaDDC).

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroup

`AColGroup.CompressionType`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`static AColGroup` `create​(int[] colIndices, int numRows, ADictionary dict, AMapToData data, int[] cachedCounts)`
`AColGroup.CompressionType` `getCompType()` Obtain the compression type.
`AColGroup` `scalarOperation​(ScalarOperator op)` Perform the specified scalar operation directly on the compressed column group, without decompressing individual cells if possible.

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.ColGroupDDC

`binaryRowOpLeft, binaryRowOpRight, estimateInMemorySize, getColGroupType, getCost, getCounts, getExactSizeOnDisk, getIdx, leftMultByMatrixNoPreAgg, preAggregateDense, preAggregateSparse, preAggregateThatDDCStructure, preAggregateThatSDCSingleZerosStructure, preAggregateThatSDCZerosStructure, readFields, sameIndexStructure, toString, unaryOperation, write`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.APreAgg

`getPreAggregateSize, leftMultByAColGroup, mmWithDictionary, preAggregate, preAggregateThatIndexStructure, tsmmAColGroup`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroupValue

`centralMoment, computeColSums, containsValue, copy, decompressToDenseBlock, decompressToSparseBlock, forceMatrixBlockDictionary, getCachedCounts, getCounts, getDictionary, getNumberNonZeros, getNumValues, replace, rexpandCols, rightMultByMatrix`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroupCompressed

`getMax, getMin, preAggRows, tsmm, unaryAggregateOperations, unaryAggregateOperations`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroup

`colSum, decompressToDenseBlock, decompressToSparseBlock, get, getColIndices, getNumCols, shiftColIndices, sliceColumn, sliceColumns`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Method Detail

#### create

    public static AColGroup create​(int[] colIndices,
                                   int numRows,
                                   ADictionary dict,
                                   AMapToData data,
                                   int[] cachedCounts)

#### getCompType

    public AColGroup.CompressionType getCompType()

Description copied from class: `AColGroup`
Obtain the compression type.

Overrides:
  `getCompType` in class `ColGroupDDC`
Returns:
  How the elements of the column group are compressed.

#### scalarOperation

    public AColGroup scalarOperation​(ScalarOperator op)

Description copied from class: `AColGroup`
Perform the specified scalar operation directly on the compressed column group, without decompressing individual cells if possible.

Overrides:
  `scalarOperation` in class `ColGroupDDC`
Parameters:
  `op` - operation to perform
Returns:
  version of this column group with the operation applied